<!DOCTYPE html>
<html lang="en">

<head>
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
    <script src="https://maxcdn.bootstrapcdn.com/bootstrap/3.4.1/js/bootstrap.min.js"></script>
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.1.3/css/bootstrap.min.css"
        integrity="sha384-MCw98/SFnGE8fJT3GXwEOngsV7Zt27NXFoaoApmYm81iuXoPkFOJwJ8ERdknLPMO" crossorigin="anonymous">

    <title>User Detail</title>
</head>

<body onload="onPageLoading()">
    <div class="jumbotron">
        <h1>Thông tin người dùng</h1>
        <div class="form-group">
            <label for="">First Name</label>
            <input id="input-first-name" type="text" class="form-control">
        </div>
        <div class="form-group">
            <label for="">last Name</label>
            <input id="input-last-name" type="text" class="form-control">
        </div>
        <div class="form-group">
            <label for="">Country</label>
            <input id="input-country" type="text" class="form-control">
        </div>
        <div class="form-group">
            <label for="">Subject</label>
            <textarea id="textarea" class="form-control"></textarea>
        </div>
        <div class="form-row">
            <div class="col">
                <button id="button-edit" class="btn btn-success" style="width: 70px;">Sửa</button>
            </div>
            <div class="col">
                <a class="nav justify-content-end">Quay lại</a>
            </div>
        </div>
    </div>
</body>
<script>
    'use strict';
    /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
    const gREQUEST_STATUS_OK = 200;
    const gREQUEST_READY_STATUS_FINISH_AND_OK = 4;
    const gBASE_URL = "http://203.171.20.210:8080/devcamp-register-java-api/users"
    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    //Hàm xử lý tải trang
    function onPageLoading() {
        var vUserObj = {
            id: "",
        }
        //B1: thu thập dữ liệu
        getDataId(vUserObj);
        //B2: validate data
        var vDuLieuHopLe = validateDataId(vUserObj);
        if(vDuLieuHopLe){
            //B3: Gọi api get user data by id
            callAPIGetDataById(vUserObj);
        }
        
    }
    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
    //Thu thập id
    function getDataId(paramUserObj) {
        //get data from query string
        var vUrlString = window.location.href; //đường đẫn gọi đến trang
        console.log(vUrlString);
        var vUrl = new URL(vUrlString);
        var vUserId = vUrl.searchParams.get("id");
        paramUserObj.id = vUserId;
    }
    //Kiểm tra dữ liệu 
    function validateDataId(paramUserObj) {
        if (paramUserObj.id === "") {
            alert("Không tìm thấy id");
            return false;
        }
        return true;
    }
    //gọi API  get user data by id
    function callAPIGetDataById(paramUserObj) {
        var vXHTMLRequest = new XMLHttpRequest();
        vXHTMLRequest.open("GET", gBASE_URL + "/" + paramUserObj.id, true);
        vXHTMLRequest.send();
        vXHTMLRequest.onreadystatechange = function () {
            if (this.readyState == gREQUEST_READY_STATUS_FINISH_AND_OK && this.status == gREQUEST_STATUS_OK) {
                //bạn hãy tự chuyển thành JSON object, past, và nghiên cứu các dữ liệu nhân về (ví dụ dùng break-point, watch; hoặc ghi ra console)
                console.log(vXHTMLRequest.responseText);  // xem trên console.log để biết cấu trúc
                // code xử lý response ở đây
                /*thêm code xử lý response*/
                //B4: hiển thị lên form
                hienThiDuLieuLenForm(vXHTMLRequest)
            }
        };
    }
    //Xử lý hiển thị dữ liệu lên form
    function hienThiDuLieuLenForm(paramXmlHttp){
        var vUserObj = JSON.parse(paramXmlHttp.responseText);
        var vFirstName = document.getElementById("input-first-name");
        var vLastName = document.getElementById("input-last-name");
        var vCountry = document.getElementById("input-country");
        var vSubject = document.getElementById("textarea");

        vFirstName.value = vUserObj.firstname;
        vLastName.value = vUserObj.lastname;
        vCountry.value = vUserObj.country;
        vSubject.value = vUserObj.subject;
    }
    
</script>

</html>